<?php

/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

namespace Kufer\KuferTools\Teilnehmer\ZsaAnmeldung\BelegungsUebersicht;

class SaveBelegungenController extends \Kufer\KuferTools\Basis\Controller\ToolController
{
  protected function getUseCase(): \Kufer\KuferTools\Basis\UseCase\UseCase
  {
    return new SaveBelegungenUseCase(
      $this->getRequestObj()
    );
  }

  protected function getRequestObj()
  {
    $requestObj = new SaveBelegungenRequest();
    
    $requestObj->bemerkungen = \PostOperations::getVarValue('bemerkung');
    $requestObj->genehmigungen = \PostOperations::getVarValue('genehmigung');
    $requestObj->prioritaeten = \PostOperations::getVarValue('prioanm');

    return $requestObj;
  }

  protected function getControllerToForward($pUseCaseResponse)
  {
    if ($pUseCaseResponse->success) {
      $statusCode = \Kufer\KuferTools\Teilnehmer\ZsaTeilnehmerUebersicht\AendereBelegung\AendereBelegungUseCase::UPDATE_BELEGUNG_SUCCESS;
    } else {
      $statusCode = \Kufer\KuferTools\Teilnehmer\ZsaTeilnehmerUebersicht\AendereBelegung\AendereBelegungUseCase::UPDATE_BELEGUNG_ERROR;
    }

    return new BelegungsUebersichtNachAbsendenController($statusCode);
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return null;
  }
}